package jp.dip.commonsense.android.mametalk;

import jp.dip.commonsense.android.mametalk.dialog.GroupChatInvitationDialog;
import jp.dip.commonsense.android.mametalk.dialog.ParticipantsDialog;
import jp.dip.commonsense.tooldroid.commons.StringUtils;
import android.database.Cursor;
import android.graphics.Color;
import android.provider.Im.BaseMessageColumns;
import android.provider.Im.MessageType;
import android.view.Menu;
import android.view.Menu.Item;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;

public class GroupChatClient extends AbstractChatActivity {

    private static final int SHOW_PARTICIPANTS_ID = Menu.FIRST;
    private static final int ADD_MEMBER_ID = Menu.FIRST + 1;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        menu.add(Menu.ALTERNATIVE, SHOW_PARTICIPANTS_ID, R.string.menu_show_participants, R.drawable.group);
        menu.add(Menu.ALTERNATIVE, ADD_MEMBER_ID, R.string.menu_add_member, R.drawable.user_add);
        return true;
    }

    @Override
    public boolean onMenuItemSelected(int featureId, Item item) {
        super.onMenuItemSelected(featureId, item);
        switch (item.getId()) {
        case SHOW_PARTICIPANTS_ID:
            new ParticipantsDialog(this, getChatSession().getParticipants()).show();
            break;
        case ADD_MEMBER_ID:
            new GroupChatInvitationDialog(this, getChatSession()).show();
            break;
        }
        return true;
    }

    @Override
    protected void fillData() {
        Cursor cursor = managedQuery(getIntent().getData(), null, null, null);
        this.setListAdapter(new SimpleCursorAdapter(this, R.layout.message_list_item, cursor,
            new String[] { BaseMessageColumns.CONTACT, BaseMessageColumns.BODY }, new int[] {
                R.id.message_contact_text, R.id.message_body_text }) {
            @Override
            public void setViewText(TextView v, String text) {
                String disp = text;
                if (v.getId() == R.id.message_contact_text) {
                    int type = mCursor.getInt(mCursor.getColumnIndex(BaseMessageColumns.TYPE));
                    switch (type) {
                    case MessageType.PRESENCE_AVAILABLE:
                        disp = StringUtils.createPreparedText(getString(R.string.info_entered_room), disp);
                        v.setTextColor(Color.GRAY);
                        break;
                    case MessageType.PRESENCE_UNAVAILABLE:
                        disp = StringUtils.createPreparedText(getString(R.string.info_left_room), disp);
                        v.setTextColor(Color.GRAY);
                        break;
                    default:
                        disp = disp + " : ";
                        break;
                    }
                }
                super.setViewText(v, disp);
            }
        });
    }
}
